var gPrintProgressListener = {
  onStateChange : function (aWebProgress, aRequest, aStateFlags, aStatus) {
    setGuardProperty(null);
    window.setTimeout(window.close, 100);
  },

  onProgressChange : function (aWebProgress, aRequest, aCurSelfProgress,
    aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {},
  onLocationChange : function (aWebProgress, aRequest, aLocation) {},
  onStatusChange : function (aWebProgress, aRequest, aStatus, aMessage) {},
  onSecurityChange : function (aWebProgress, aRequest, aState) {},

  QueryInterface : function progress_qi(aIID) {
    if (!aIID.equals(Components.interfaces.nsISupports)
      && !aIID.equals(Components.interfaces.nsIWebProgressListener))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  }
};

function setGuardProperty(aValue) {
    return Components.classes["@mozilla.org/persistent-properties;1"]
      .getService(Components.interfaces.nsIPersistentProperties)
      .setStringProperty("extension.printpdf.printing", aValue);
}

function startup() {
  var browser = document.getElementById("content");
  browser.addEventListener("pageshow", onPrintPageShow, false);
  var uri = window.arguments ? window.arguments[0] : "";
  try {
    browser.loadURI(uri);
  }
  catch (e) {
    // print error message
    window.setTimeout(window.close, 100);
  }
}

function onPrintPageShow() {
  if (setGuardProperty("yes")) {
    window.setTimeout(onPrintPageShow, 100);
    return;
  }

  var printSettingsService =
    Components.classes["@mozilla.org/gfx/printsettings-service;1"]
      .getService(Components.interfaces.nsIPrintSettingsService);

  var settings = printSettingsService.newPrintSettings;
  settings.printerName = printSettingsService.defaultPrinterName;

  printSettingsService.initPrintSettingsFromPrefs(settings, true,
    settings.kInitSaveAll);

  settings.printToFile = true;
  settings.toFileName = (window.arguments && window.arguments[1]) ?
    window.arguments[1] : "mozilla.pdf";
  settings.outputFormat = Components.interfaces.nsIPrintSettings
    .kOutputFormatPDF;
  settings.printSilent = true;

  content.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
    .getInterface(Components.interfaces.nsIWebBrowserPrint)
    .print(settings, gPrintProgressListener);
}
